# Gamerules
gamerule doImmediateRespawn false
gamerule spectatorsGenerateChunks true

# Revive
execute at @e[nbt={Item:{components:{"minecraft:custom_data":{Revive:1}}},PickupDelay:0s}] run tag @p[distance=..2,gamemode=spectator] add Revive
execute at @a[tag=Revive] run kill @e[nbt={Item:{components:{"minecraft:custom_data":{Revive:1}}}},limit=1,distance=..5]
execute at @a[tag=Revive] run gamemode survival @p
execute at @a[tag=Revive] run effect give @p minecraft:slowness 60 2 true
execute at @a[tag=Revive] run effect give @p minecraft:weakness 60 2 true
execute at @a[tag=Revive] run effect give @p minecraft:glowing 60 2 true
execute at @a[tag=Revive] run effect give @p minecraft:hunger 60 2 true
execute at @a[tag=Revive] run effect give @p minecraft:mining_fatigue 60 2 true
execute at @a[tag=Revive] run effect give @p minecraft:poison 2 0 true
execute at @a[tag=Revive] run scoreboard players add @p Blood 1
execute at @a[tag=Revive] run scoreboard players add @p Minutes 4
execute at @a[tag=Revive] run scoreboard players add @p Seconds 59
execute at @a[tag=Revive] run playsound minecraft:ui.toast.challenge_complete master @a ~ ~ ~ 10 1

execute at @a[tag=Revive] run tag @p remove Revive

# Set spawn
execute at @a[scores={health=0}] if dimension minecraft:overworld run spawnpoint @p ~ ~1 ~
execute at @a[scores={health=0}] if dimension minecraft:the_nether run spawnpoint @p ~ ~1 ~

# Ghost particles
execute at @a[gamemode=spectator] run particle dust{color:[1.000,1.000,1.000],scale:1} ~ ~1.5 ~ 0.5 0.5 0.5 0 2 force

# Scare
execute at @a[gamemode=spectator] run tag @e[type=!minecraft:player,distance=..0.8] add Scared
data modify entity @e[tag=Scared,limit=1,nbt=!{TicksFrozen:0}] TicksFrozen set value 140
effect give @e[tag=Scared,nbt=!{active_effects:[{id:"minecraft:wither"}]}] minecraft:wither 3 0 true

tag @e[type=!minecraft:player] remove Scared

# Possess
execute at @a[gamemode=spectator] run tag @a[distance=..1,gamemode=survival] add Possessed
effect give @a[tag=Possessed] minecraft:strength 1 0 true
effect give @a[tag=Possessed] minecraft:speed 1 0 true
effect give @a[tag=Possessed] minecraft:resistance 1 0 true
effect give @a[tag=Possessed] minecraft:glowing 1 0 true
tag @a remove Possessed

# Tick Timer
scoreboard players add @a Timer 1
execute as @a if score @s Timer matches 20.. run scoreboard players set @a Timer 0

# Cooldown Timer
execute as @a[scores={Blood=1..,Seconds=0..,Timer= 19..}] run scoreboard players remove @s Seconds 1
execute as @a[scores={Blood=1..,Minutes=1..,Seconds=..-1,Timer=19..}] run function n-hr:minute_change
execute as @a[scores={Blood=1..,Minutes=0,Seconds=..-1,Timer=19..}] run function n-hr:reset_cooldown
execute as @a[scores={Seconds=60..}] run function n-hr:minute_overflow

# Display Timer
execute as @a[gamemode=!spectator,scores={Blood=1..}] run title @s actionbar ["",{"text":"Time Left: ","color":"gray"},{"score":{"name":"@s","objective":"Minutes"}},{"text":"m "},{"score":{"name":"@s","objective":"Seconds"}},{"text":"s"}]

# Health Debuffs
execute at @a[scores={Blood=0}] run attribute @p[scores={Blood=0}] minecraft:generic.max_health base set 20
execute at @a[scores={Blood=1}] run attribute @p[scores={Blood=1}] minecraft:generic.max_health base set 10
execute at @a[scores={Blood=2}] run attribute @p[scores={Blood=2}] minecraft:generic.max_health base set 5
execute at @a[scores={Blood=3}] run attribute @p[scores={Blood=3}] minecraft:generic.max_health base set 2

# Fix scores
scoreboard players set @a[tag=!nHrCheck] Blood 0
scoreboard players set @a[tag=!nHrCheck] Seconds 0
scoreboard players set @a[tag=!nHrCheck] Minutes 0

# Remove spectator cooldowns
execute as @a[gamemode=spectator] run scoreboard players set @s Seconds 0
execute as @a[gamemode=spectator] run scoreboard players set @s Minutes 0
execute as @a[gamemode=spectator] run scoreboard players set @s Blood 0

tag @a add nHrCheck